;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/33/LISPcapi-examples/RCS/choice:option-pane.lisp,v 1.6.9.1 2009/08/21 21:13:02 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

;;----------------------------------------------------------------------------
;;
;; examples/capi/choice/option-pane.lisp
;;
;; This example demonstrates the uses of option-panes in the CAPI.
;; To try it, compile and load this file and then execute:
;;
;;      (CL-USER::TEST-OPTION-PANE)
;;
;;----------------------------------------------------------------------------

(in-package "CL-USER")


;;----------------------------------------------------------------------------
;; Define the interface option-pane-test
;;----------------------------------------------------------------------------

(capi:define-interface option-pane-test ()
  () 
  (:panes
   (color-chooser
    capi:option-pane
    :accessor color-chooser
    :title "Color:"
    :items '(:red :green :blue :separator :white :black)
    :separator-item :separator
    :print-function 'string-capitalize
    :selection-callback 'option-pane-set-color)
   (color-kind
    capi:radio-button-panel
    :accessor color-kind
    :items '(:all :primary)
    :print-function 'string-capitalize
    :selection-callback 'option-pane-set-color-kind)
   (color-square
    capi:output-pane
    :accessor color-square))
  (:layouts
   (default-layout
    capi:column-layout
    '(color-chooser color-kind color-square)))
  (:default-initargs
   :title "Option Pane Test"
   :best-height 200))

(defmethod initialize-instance :after ((self option-pane-test) &key color)
  (option-pane-set-color (or color
                             (capi:choice-selected-item (color-chooser self)))
                         self))


;;----------------------------------------------------------------------------
;; A generic callback
;;----------------------------------------------------------------------------

(defun option-pane-set-color (color interface)
  (setf (capi:simple-pane-background (color-square interface)) color))

(defun option-pane-set-color-kind (kind interface)
  (setf (capi:option-pane-enabled-positions (color-chooser interface))
        (if (eq kind :all)
            :all
          '(0 1 2))))


;;----------------------------------------------------------------------------
;; A simple test function
;;----------------------------------------------------------------------------

(defun test-option-pane ()
  (capi:display (make-instance 'option-pane-test)))
