;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/33/LISPcapi-examples/RCS/choice:tree-view.lisp,v 1.7.8.1 2009/08/21 21:13:00 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

;;----------------------------------------------------------------------------
;;
;; examples/capi/choice/tree-view.lisp
;;
;; This example demonstrates the uses of the tree-view in the CAPI.
;; To try it, compile and load this file and then execute:
;;
;;      (CL-USER::TEST-TREE-VIEW)
;;
;;----------------------------------------------------------------------------


(in-package "CL-USER")


;;----------------------------------------------------------------------------
;; Create an image list for use by the tree-view
;;----------------------------------------------------------------------------

(defvar *my-image-list*
  (make-instance 'capi:image-list
		  :image-sets (list (capi:make-general-image-set
				     :id #.(gp:read-external-image
                                            (current-pathname"tree.bmp"))
				     :image-count 4))
		  :image-width 16
		  :image-height 16))


;;----------------------------------------------------------------------------
;; Define the interface option-pane-test
;;----------------------------------------------------------------------------

(capi:define-interface tree-view-test ()
  () 
  (:panes
   (tree capi:tree-view
         :roots '(1 2 3 4)
         :children-function #'(lambda (x)
                                (and (< x 100)
                                     (let ((base (* x 4)))
                                       (list (+ base 1)
                                             (+ base 2)
                                             (+ base 3)
                                             (+ base 4)))))
         :image-lists (list :normal *my-image-list*)
         :image-function #'(lambda (x) (mod (1- x) 4))
         :visible-min-width 200
         :visible-min-height 200
         :retain-expanded-nodes t
         :print-function #'(lambda(x) (format nil "~d : ~r" x x ))
         :selection-callback #'(lambda (item self)
                                 (declare (ignore self))
                                 (format t "~&Select item ~S~%" item))
         :action-callback #'(lambda (item self)
                              (declare (ignore self))
                              (format t "~&Activate item ~S~%" item))
         :delete-item-callback #'(lambda (self item)
                                   (declare (ignore self))
                                   (format t "~&Delete item ~S~%" item))))
  (:layouts
   (default-layout
    capi:simple-layout
    '(tree)))
  (:default-initargs
   :title "Tree View Test"))


;;----------------------------------------------------------------------------
;; A simple test function
;;----------------------------------------------------------------------------

(defun test-tree-view ()
  (capi:display (make-instance 'tree-view-test)))
