;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/33/LISPcapi-examples/RCS/elements:cursor.lisp,v 1.1.9.1 2009/08/21 21:13:00 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

(in-package "CL-USER")

;;; ----------------------------------------------------------------------
;;;
;;; Example use of mouse cursors.
;;;
;;; To try it, compile and load this file and then execute:
;;;
;;;      (CL-USER::TEST-MOUSE-CURSOR)
;;;
;;; ----------------------------------------------------------------------

(capi:define-interface mouse-cursor-example ()
  ()
  (:panes
   (cursor-pane
    capi:output-pane
    :input-model '(((:button-1 :press) pane-toggle-mouse-cursor))
    :background (color:make-rgb 0.0 0.5 0.0)
    :visible-min-width 300
    :visible-min-height 300)
   (button
    capi:push-button
    :text "Change Cursor"
    :callback 'toggle-mouse-cursor
    :callback-type :interface)))

(defun pane-toggle-mouse-cursor (pane x y)
  (declare (ignore x y))
  (toggle-mouse-cursor (capi:top-level-interface pane)))

(defun toggle-mouse-cursor (interface)
  (with-slots (cursor-pane) interface
    (setf (capi:simple-pane-cursor cursor-pane)
          (if (capi:simple-pane-cursor cursor-pane)
              nil
            :i-beam))))

(defun test-mouse-cursor ()
  (capi:display (make-instance 'mouse-cursor-example)))

