;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/33/LISPcapi-examples/RCS/graphics:pinboard-object-text-pane.lisp,v 1.1.10.1 2009/08/21 21:12:59 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

;;
;; An example way to create a multi-line text pane implemented
;; entirely in pinboard-objects.
;;
;;----------------------------------------------------------------------------
;;
;; To run this example, compile and load this file and then execute:
;;
;;       (cl-user::test-multi-line-text-panes)
;;
;;----------------------------------------------------------------------------

(in-package "CL-USER")

;;----------------------------------------------------------------------------
;; Multi-line-text-pane definition
;;----------------------------------------------------------------------------
(defclass multi-line-text-pane (capi:column-layout)
  ((width-of-text :initarg :width-of-text :reader width-of-text))
  (:default-initargs
   :y-gap 0))

(defmethod (setf multi-line-text-pane-text) (text (self multi-line-text-pane))
  (let ((strings (capi:wrap-text text (width-of-text self))))
    (setf (capi:layout-description self)
          (loop for string in strings
                collect (make-instance 'capi:item-pinboard-object
                                       :text string)))))

(defmethod initialize-instance :after ((self multi-line-text-pane)
                                       &key text (x-adjust :left))
  (declare (ignorable x-adjust))
  (setf (multi-line-text-pane-text self) text))

;;----------------------------------------------------------------------------
;; test function
;;----------------------------------------------------------------------------
(defun test-multi-line-text-panes (&optional (text-width 30))
  (capi:contain
   (make-instance
    'capi:column-layout
    :y-gap 5
    :description (list
                  (make-instance 'multi-line-text-pane
                                 :text "This text will be left aligned in the pane. It will be aligned on the left."
                                 :width-of-text text-width)
                  (make-instance 'multi-line-text-pane
                                 :x-adjust :centre
                                 :text "This text will be centered in the middle of this pane. It will be centered."
                                 :width-of-text text-width)
                  (make-instance 'multi-line-text-pane
                                 :x-adjust :right
                                 :text "This text will be right aligned in the pane. It will be aligned on the right."
                                 :width-of-text text-width)))))
