;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/23/LISPexamples/RCS/editor:commands:spell-word.lisp,v 1.2.11.1 2009/08/21 21:12:57 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

(in-package "CL-USER")

;;; ----------------------------------------------------------------------
;;; Spell Word - CURRENTLY ONLY WORKS ON UNIX LISPWORKS/LIQUID-CL
;;; Place the cursor at the end of the word and run the command
;;; "Spell Word". This will call the unix command (default - "spell")  to
;;; verify the spelling of the current word. The result of the check will
;;; be displayed in the echo area.
;;; ----------------------------------------------------------------------

(editor:defcommand "Spell Word" (p)
     "Prompt for and run a shell command on the current region.
If given an argument, the output replaces the region.
Otherwise the output is placed in the shell output buffer"
     "Prompt for and run a shell command on the current region"
  (spell-word  p))

(defvar *spell-command* "spell"
  "The name of the unix command used by \"Spell Word\"")

(defun spell-word (p)
  (editor:backward-word-command p)
  (let* ((end-point (editor:copy-point (editor:current-point)))
         (word (progn 
                 (editor:forward-word-command p)
                 (editor:points-to-string end-point (editor:current-point)))))
    (editor:message "Spelling word ~S" word)
    (multiple-value-bind (result output)
        (sys::call-system-showing-output
         (format nil "echo ~a | ~A~%" word *spell-command*)
         :show-cmd nil
         :output-stream nil)
      (cond
       ((/= 0 result) (editor:message "Call to ~S failed!" *spell-command*))
       ((string= output "") (editor:message "Spelling correct!"))
       (t (editor:message "Incorrect spelling : ~S" word))))))


