;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/23/LISPexamples/RCS/editor:commands:split-line.lisp,v 1.1.12.1 2009/08/21 21:12:59 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

;; This code adds a command corresponding to GNU Emacs "split-line" to
;; the LW editor
;; Demonstrates the use of: DEFCOMMAND, CURRENT-POINT, COPY-POINT. 
;; LINE-START, POINTS-TO-STRING, INSERT-STRING, MOVE-POINT, BIND-KEY

(in-package "CL-USER")

(editor:defcommand "Split Line" (p)
  (declare (ignore p))
  (let* ((cur-point (editor:current-point))
         (start-point (editor:copy-point cur-point :temporary))
         (temp-point (editor:copy-point cur-point :temporary)))
    (editor:line-start temp-point)
    ;; Insert newline and correct number of spaces
    (let ((insert-length (length (editor:points-to-string temp-point start-point))))
      (editor:new-line-command nil)
      (editor:insert-string cur-point (make-string insert-length :initial-element #\Space)))
    ;; Leave point where you found it
    (editor:move-point cur-point start-point)))

(editor:bind-key "Split Line" #\C-M-\o)
