;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/23/LISPexamples/RCS/ssl:ssl-client.lisp,v 1.2.8.1 2009/08/21 21:12:58 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

;;; A test for the client side of SSL
;;; compile and load and then test by:
;;;    (try-yahoo)
;;; Should output: 

;;; 1. www.yahoo.com [NIL] => HTTP/1.1 200 OK
;;; 2. www.yahoo.com [T] =>  <some error>
;;; 3. login.yahoo.com [NIL] =>  <some error>
;;; 4. login.yahoo.com [T] => HTTP/1.1 200 OK

;;; 1. The first call (plain call to www.yahoo.com:80)  succeeds.
;;; 2. The second call (SSL call to www.yahoo.com:80) fails
;;;    because www.yahoo.com:80 doesn't reponds correctly to SSL calls.
;;; 3. The third call (plain call to login.yahoo.com:443)fails 
;;;    because login.yahoo.com:443 expects ssl calls.
;;; 4. The fourth call (SSL call to login.yahoo.com:443) succeeds


(in-package "CL-USER")


(defun call-get(stream)
  (format stream "GET / HTTP/1.0~2%")
  (finish-output stream))

(defun read-a-line (pp)
  (delete #\return (read-line pp)))

(defun get-first-line (pp)
      (unwind-protect
          (progn (call-get pp )
            (read-a-line pp))
     (close pp)))



(defun yahoo-ssl ()
   (let ((pp (comm::open-tcp-stream "login.yahoo.com" 443 :ssl-ctx t)))
    (get-first-line pp)))

(defun yahoo (num &key ssl-ctx (page "www.yahoo.com") (port 80))
  (let ((pp (comm::open-tcp-stream page port :ssl-ctx ssl-ctx)))
    (format t "~a: ~a:~a [~a] => " num page port ssl-ctx )
    (Let ((line (get-first-line pp)))
      (format t "~a~%"  line))))


(defun try-yahoo()
  (handler-bind ((error #'(lambda(cc) (format t "~a~%" cc ) (abort))))
    (yahoo 1)
    (with-simple-restart (abort "abort")
      (yahoo 2 :ssl-ctx t))
    (with-simple-restart (abort "abort")
      (yahoo 3 :page "login.yahoo.com" :port 443))
    (yahoo 4 :page "login.yahoo.com" :ssl-ctx t :port 443)))
