;; -*- Mode: Lisp; rcs-header: "$Header: /hope/lwhope1-cam/hope.0/compound/15/LISPprocesses/RCS/comm-pkg.lisp,v 1.27.7.1 2009/08/21 21:14:54 davef Exp $" -*-

;; Copyright (c) 1987--2010 LispWorks Ltd. All rights reserved.

(in-package "SYS")

(defpackage "COMM"
  (:add-use-defaults)
  (:export
    "OPEN-TCP-STREAM"
    "START-UP-SERVER"
    "SOCKET-ERROR"
    "SOCKET-STREAM"
    "SOCKET-STREAM-SOCKET"
    "SOCKET-STREAM-PEER-ADDRESS"
    "SOCKET-STREAM-ADDRESS"
    "CONNECT-TO-TCP-SERVER"
    "GET-SOCKET-PEER-ADDRESS"
    "GET-SOCKET-ADDRESS"
    "GET-HOST-ENTRY"
    "GET-SERVICE-ENTRY"
    "IP-ADDRESS-STRING"
    "STRING-IP-ADDRESS")
  (:export    

   "SSL-CTX-POINTER"  ;; foreign type
   "SSL-POINTER"      ;; foreign type
   "ATTACH-SSL"
   "SOCKET-STREAM-CTX" 
   "SOCKET-STREAM-SSL" 
   "SOCKET-STREAM-SSL-SIDE"
   "DETACH-SSL"
   "SOCKET-STREAM-HANDSHAKE"
   
   "DEF-OPENSSL-FUNCTION" ;;; so can send source code

   "SSL-CONDITION" 
   "SSL-X509-LOOKUP"
   "SSL-FAILURE"
   "SSL-ERROR"
   "SSL-CLOSED"

   "SET-SSL-LIBRARY-PATH"
   "MAKE-SSL-CTX"
   "ENSURE-SSL"
   "DO-RAND-SEED"
   
   "OPENSSL-VERSION"

   "SSL-SET-CONNECT-STATE"
   "SSL-SET-ACCEPT-STATE"
   "SSL-NEW"
   "SSL-CTX-NEW"
   "DESTROY-SSL" ;"SSL-FREE"
   "DESTROY-SSL-CTX" ; "SSL-CTX-FREE"
   "SSL-SHUTDOWN" 
   "SSL-GET-SSL-CTX"
   "SSL-GET-STREAM"
   "RAND-SEED" 
   "DISABLE-RAND-SEED"
   "RAND-LOAD-FILE"
   "SSL-SET-MODE"
   "SSL-CTX-SET-MODE"
   "SSL-CLEAR"
   "SET-SSL-CTX-DH"
   "SSL-SET-TMP-DH"
   "SSL-CTX-SET-TMP-DH"
   "SSL-CTX-CTRL"  ;;; documented but not supposed to be called. 
   "SSL-CTRL"  ;;; documented but not supposed to be called. 



   ;;; the following are "direct calls", but in C they are
   ;;; macros, so we define them using SSL-CTX-CTRL 
   ;;; and SSL-CTRL
   "SSL-CTX-SET-MODE"
   "SSL-SET-MODE"
   "SSL-CTX-SET-OPTIONS"
   "SSL-SET-OPTIONS"
   "SSL-CTX-GET-MODE"
   "SSL-GET-MODE"
   "SSL-CTX-GET-OPTIONS"
   "SSL-GET-OPTIONS"
   "SSL-SESSION-REUSED"
   "SSL-NUM-RENEGOTIATIONS"
   "SSL-CLEAR-NUM-RENEGOTIATIONS"
   "SSL-TOTAL-RENEGOTIATIONS"
   "SSL-NEED-TMP-RSA"
   "SSL-CTX-NEED-TMP-RSA"
   "SSL-CTX-SET-TMP-RSA"
   "SSL-CTX-SET-TMP-DH"
   "SSL-CTX-ADD-EXTRA-CHAIN-CERT"
   "SSL-SET-TMP-RSA"
   "SSL-SET-TMP-DH"
   "SSL-CTX-SESS-SET-CACHE-SIZE"
   "SSL-CTX-SESS-GET-CACHE-SIZE"
   "SSL-CTX-SESS-SET-CACHE-MODE"
   "SSL-CTX-SESS-GET-CACHE-MODE"
   "SSL-CTX-SET-READ-AHEAD"
   "SSL-CTX-GET-READ-AHEAD"
   "SSL-CTX-SET-MAX-CERT-LIST"
   "SSL-CTX-GET-MAX-CERT-LIST"
   "SSL-SET-MAX-CERT-LIST"
   "SSL-GET-MAX-CERT-LIST"


   "SET-SSL-CTX-OPTIONS"

   "SET-CIPHER-LIST"
   "SET-SSL-CTX-PASSWORD-CALLBACK"
   "SSL-CTX-USE-CERTIFICATE-CHAIN-FILE"
   "SSL-CTX-USE-RSAPRIVATEKEY-FILE"
   "SET-SSL-CTX-DH" 
   "SSL-CTX-USE-CERTIFICATE-FILE"
   "SSL-USE-CERTIFICATE-FILE"
   "SSL-CTX-USE-PRIVATEKEY-FILE"
   "SSL-USE-RSAPRIVATEKEY-FILE"
   "SSL-USE-PRIVATEKEY-FILE"
   "SSL-CTX-SET-CLIENT-CA-LIST"
   "SSL-CTX-ADD-CLIENT-CA"
   "SSL-SET-CLIENT-CA-LIST"
   "SSL-ADD-CLIENT-CA"
   "SSL-LOAD-CLIENT-CA-FILE"
   "SSL-CTX-LOAD-VERIFY-LOCATIONS"


   "SSL-CTX-GET-CERT-STORE"
   "SSL-CTX-GET-VERIFY-MODE"
   "SSL-GET-VERIFY-MODE"

   "SSL-CIPHER-GET-BITS"
   "SSL-CIPHER-GET-VERSION"
   "SSL-CIPHER-GET-NAME"

   "SSL-GET-CURRENT-CIPHER"

   "SSL-GET-VERSION"   ;;; version of ssl 

   "PEM-READ"
   "READ-DHPARAMS"


   "SSL_FILETYPE_PEM";;; files types 
   "SSL_FILETYPE_ASN1" ;;; file types

   ;;; Crypto high level functionality 
   "SET-VERIFICATION-MODE"
   "GET-VERIFICATION-MODE"
   "SET-VERIFICATION-DEPTH"
   "SET-SESSION-ID-CONTEXT"
   "SSL-GET-VERIFY-RESULT"
   "SSL-GET-PEER-CERT-CHAIN"
   "SSL-GET-PEER-CERTIFICATE"
   "SSL-GET-CERTIFICATE"

   "SSL-USE-PRIVATE-KEY"
   "SSL-CTX-USE-PRIVATE-KEY"
   "SSL-USE-CERTIFICATE"
   "SSL-CTX-USE-CERTIFICATE"
   "SET-SSL-CTX-CERT-CB"


   ;;;;;  crypto foreign types
    
   "NID"

   "BIO-POINTER"
   "ASN1-STRING-POINTER"
   "ASN1-OBJECT-POINTER"
   "ASN1-TYPE-POINTER"
   "ASN1-TIME-POINTER"
   "ASN1-INTEGER-POINTER"
   "ASN1-BIT-STRING-POINTER"

   "CRYPTO-STACK-POINTER"
   "ASN1-OCTET-STRING-POINTER"
   "EVP-PKEY-POINTER"
   "X509-EXTENSION-POINTER"
   "X509-ALGOR-POINTER"
   "X509-PUBKEY-POINTER"
   "X509-VAL-POINTER"
   "X509-CERT-POINTER"
   "X509-POINTER"
   "X509-NAME-POINTER"
   "X509-NAME-ENTRY-POINTER"
   "X509-STORE-CTX-POINTER"
   "X509-STORE-POINTER"
   "PLAIN-THING-POINTER"
   "SSL-CIPHER-POINTER"

   "BIO-POINTER-STACK"
   "ASN1-STRING-POINTER-STACK"
   "ASN1-OBJECT-POINTER-STACK"
   "ASN1-TYPE-POINTER-STACK"
   "ASN1-TIME-POINTER-STACK"
   "ASN1-INTEGER-POINTER-STACK"
   "ASN1-BIT-STRING-POINTER-STACK"
   "ASN1-OCTET-STRING-POINTER-STACK"
   "EVP-PKEY-POINTER-STACK"
   "X509-EXTENSION-POINTER-STACK"
   "X509-ALGOR-POINTER-STACK"
   "X509-PUBKEY-POINTER-STACK"
   "X509-VAL-POINTER-STACK"
   "X509-CERT-POINTER-STACK"
   "X509-POINTER-STACK"
   "X509-NAME-POINTER-STACK"
   "X509-NAME-ENTRY-POINTER-STACK"
   "PLAIN-THING-POINTER-STACK"
   "SSL-CIPHER-POINTER-STACK"
   "X509-STORE-POINTER-STACK"
   "DEFINE-CRYPTO-POINTER"
   "DEFINE-CRYPTO-STACK-SUBTYPE"

   ;;; Generalized-time
   
   "GMOFFSET-TO-STRING (GMOFFSET &OPTIONAL STREAM)"
   "GENERALIZED-TIME"
   "GENERALIZED-TIME-UNIVERSAL-TIME"
   "GENERALIZED-TIME-MICROSECONDS"
   "GENERALIZED-TIME-GMOFFSET"
   "MAKE-GENERALIZED-TIME"
   "GENERALIZED-TIME-PPRINT (GT STREAM)"
   "GENERALIZED-TIME-STRING (GT)"
   "ASN1-TIME-TO-GENERALIZED-TIME"
   "STRING-ASN1-TIME-TO-GENERALIZE-TIME"
   "STRING-DER-TIME-TO-GENERALIZED-TIME"
   "POINTER-DER-TIME-TO-GENERALIZED-TIME"
   "GENERALIZED-TIME-TO-DER-TIME-STRING"
   "DER-TIME-STRING-TO-ASN1-TIME"
   "GENERALIZED-TIME-TO-ASN1-TIME"

   ;;;; utiltities

   "INCREASE-REFERENCES-COUNT"
   "OPENSSL-FREE"
   "ASN1-STRING-TO-UTF8"
   "ASN1-STRING-FREE"
   "ASN1-RAW-BYTES-TO-I-VECTOR"
   "ASN1-INTEGER-GET1"
   "ASN1-INTEGER-TO-DECIMAL-STRING"
   "ASN1-STRING-TO-LISP-STRING"


   "OBJ-OBJ2NID"
   "OBJ-NID2OBJ"
   "OBJ-NID2SN"
   "OBJ-NID2LN"
   "CONVERT-TO-NID"


   ;;;; X509 readers

   "X509-GET-ISSUER-NAME"
   "X509-GET-SUBJECT-NAME"
   "X509-GET-SERIAL-NUMBER"
   "X509-NAME" 
   "X509-PATH-LEN"
   "X509-CA"
   "X509-KEY-USAGE"
   "X509-NETSCAPE-CERTIFICATE-TYPE"
   "X509-EXTENDED-KEY-USAGE"
   "X509-SHA-DIGEST"
   "X509-VERSION"
   "X509-STARTING-TIME"
   "X509-EXPIRY-TIME"
   "X509-SERIAL-NUMBER"
   "X509-GET-PUBKEY"
   "X509-PUBKEY"
   "X509-PUBKEY-ALGORITHM-NID"
   "X509-PUBKEY-ALGORITHM"
   "X509-PUBKEY-KEY"
   "X509-SIGNATURE-ALGORITHM-NID"
   "X509-SIGNATURE-ALGORITHM"
   "X509-SIGNATURE-VALUE"
   "X509-GET-EMAIL"
   "X509-GET1-EMAIL"

   "X509-CHECK-PRIVATE-KEY" ;; not really accessors

   ;;; X509-NAME readers


   "X509-NAME-GET-INDEX-BY-NID"
   "X509-NAME-ENTRY-COUNT"
   "X509-NAME-INDEX-TO-STRING"
   "X509-NAME-FIELD-STRING"
   "X509-NAME-FIELD-VALUES"
   "X509-NAME-FIELD-COUNT"
   "X509-NAME-GET-ALL-VALUES-NIDS"
   "X509-NAME-GET-ALL-VALUES"

   ;;;; Stack functionality


   "SK-FIND"
   "SK-FREE"
   "SK-DELETE"
   "SK-DELETE-PTR"
   "SK-INSERT-DATA"
   "SK-NEW-NULL"
   "SK-NEW"
   "SK-NUM"
   "SK-POP"
   "SK-POP-FREE"
   "SK-PUSH"
   "SK-SHIFT"
   "SK-UNSHIFT"
   "SK-VALUE"
   "SK-ZERO"

   "MAP-CRYPTO-STACK-OBJECTS"
   "CRYPTO-STACK-REF"
   "CONVERT-LIST-TO-CRYPTO-STACK"
   "FREE-CRYPTO-STACK-AND-OBJECTS"
   "CRYPTO-STACK-FREE"
   "CRYPTO-STACK-COUNT"

   ;;;; X509-EXTENSION readers


   "X509-GET-EXTENSIONS"
   "MAP-X509-EXTENSION"
   "FIND-X509-EXTENSION"
   "X509-EXTENSION-GET-OBJECT"
   "X509-EXTENSION-GET-CRITICAL"
   "X509-EXTENSION-DATA"
   "X509-GET-EXT"
   "X509-GET-EXT-BY-NID"
   "X509-CHECK-PURPOSE"
   "X509-PURPOSE-VALID-P"
   "X509V3-EXT-PRINT"
   "X509-EXTENSION"
   "X509-EXTENSION-NID"
   "X509-EXTENSION-STRING"
   "X509-EXTENSION-RAW-BYTES"
   "X509-EXTENSION-CRITICAL"
   "MAKE-X509-EXTENSION"
   "X509-EXTENSION-P"
   "GET-ALL-EXTENSION-VALUES-NIDS"

   ;;;; BIO functions


   "BIO-NEW"
   "BIO-S-MEM"
   "BIO-NEW-MEM"
   "BIO-READ"
   "BIO-CTRL"
   "BIO-FREE"
   "GET-BIO-MEM-STRING"
   "WITH-MEM-BIO"

   ;;; Reading functions


   "READ-CERTIFICATE-FILE"
   "READ-PRIVATE-KEY-FILE"
   "READ-CERTIFICATE-KEY-PAIRS"
   "FREE-CERTIFICATE-KEY-PAIRS"
   "COMBINE-CERTIFICATES-AND-KEYS"


   ;;; X509-STORE-CTX-
   "X509-STORE-CTX-GET-CURRENT-CERT"
   "X509-STORE-CTX-GET-CHAIN"
   "X509-STORE-CTX-GET-STORE"
   "X509-STORE-CTX-GET-SSL"
   "X509-STORE-CTX-GET-ERROR"
   "X509-STORE-CTX-SET-ERROR"

   ;;misc 
   "LW-CRYPTO-SET-DEBUG"
   )

  (:export ;;; NIDS. I am not we need these
   "NID_UNDEF"
   "NID_RSADSI"
   "NID_PKCS"
   "NID_MD2"
   "NID_MD5"
   "NID_RC4"
   "NID_RSAENCRYPTION"
   "NID_MD2WITHRSAENCRYPTION"
   "NID_MD5WITHRSAENCRYPTION"
   "NID_PBEWITHMD2ANDDES_CBC"
   "NID_PBEWITHMD5ANDDES_CBC"
   "NID_X500"
   "NID_X509"
   "NID_COMMONNAME"
   "NID_COUNTRYNAME"
   "NID_LOCALITYNAME"
   "NID_STATEORPROVINCENAME"
   "NID_ORGANIZATIONNAME"
   "NID_ORGANIZATIONALUNITNAME"
   "NID_RSA"
   "NID_PKCS7"
   "NID_PKCS7_DATA"
   "NID_PKCS7_SIGNED"
   "NID_PKCS7_ENVELOPED"
   "NID_PKCS7_SIGNEDANDENVELOPED"
   "NID_PKCS7_DIGEST"
   "NID_PKCS7_ENCRYPTED"
   "NID_PKCS3"
   "NID_DHKEYAGREEMENT"
   "NID_DES_ECB"
   "NID_DES_CFB64"
   "NID_DES_CBC"
   "NID_DES_EDE_ECB"
   "NID_DES_EDE3_ECB"
   "NID_IDEA_CBC"
   "NID_IDEA_CFB64"
   "NID_IDEA_ECB"
   "NID_RC2_CBC"
   "NID_RC2_ECB"
   "NID_RC2_CFB64"
   "NID_RC2_OFB64"
   "NID_SHA"
   "NID_SHAWITHRSAENCRYPTION"
   "NID_DES_EDE_CBC"
   "NID_DES_EDE3_CBC"
   "NID_DES_OFB64"
   "NID_IDEA_OFB64"
   "NID_PKCS9"
   "NID_PKCS9_EMAILADDRESS"
   "NID_PKCS9_UNSTRUCTUREDNAME"
   "NID_PKCS9_CONTENTTYPE"
   "NID_PKCS9_MESSAGEDIGEST"
   "NID_PKCS9_SIGNINGTIME"
   "NID_PKCS9_COUNTERSIGNATURE"
   "NID_PKCS9_CHALLENGEPASSWORD"
   "NID_PKCS9_UNSTRUCTUREDADDRESS"
   "NID_PKCS9_EXTCERTATTRIBUTES"
   "NID_NETSCAPE"
   "NID_NETSCAPE_CERT_EXTENSION"
   "NID_NETSCAPE_DATA_TYPE"
   "NID_DES_EDE_CFB64"
   "NID_DES_EDE3_CFB64"
   "NID_DES_EDE_OFB64"
   "NID_DES_EDE3_OFB64"
   "NID_SHA1"
   "NID_SHA1WITHRSAENCRYPTION"
   "NID_DSAWITHSHA"
   "NID_DSA_2"
   "NID_PBEWITHSHA1ANDRC2_CBC"
   "NID_ID_PBKDF2"
   "NID_DSAWITHSHA1_2"
   "NID_NETSCAPE_CERT_TYPE"
   "NID_NETSCAPE_BASE_URL"
   "NID_NETSCAPE_REVOCATION_URL"
   "NID_NETSCAPE_CA_REVOCATION_URL"
   "NID_NETSCAPE_RENEWAL_URL"
   "NID_NETSCAPE_CA_POLICY_URL"
   "NID_NETSCAPE_SSL_SERVER_NAME"
   "NID_NETSCAPE_COMMENT"
   "NID_NETSCAPE_CERT_SEQUENCE"
   "NID_DESX_CBC"
   "NID_ID_CE"
   "NID_SUBJECT_KEY_IDENTIFIER"
   "NID_KEY_USAGE"
   "NID_PRIVATE_KEY_USAGE_PERIOD"
   "NID_SUBJECT_ALT_NAME"
   "NID_ISSUER_ALT_NAME"
   "NID_BASIC_CONSTRAINTS"
   "NID_CRL_NUMBER"
   "NID_CERTIFICATE_POLICIES"
   "NID_AUTHORITY_KEY_IDENTIFIER"
   "NID_BF_CBC"
   "NID_BF_ECB"
   "NID_BF_CFB64"
   "NID_BF_OFB64"
   "NID_MDC2"
   "NID_MDC2WITHRSA"
   "NID_RC4_40"
   "NID_RC2_40_CBC"
   "NID_GIVENNAME"
   "NID_SURNAME"
   "NID_INITIALS"
   "NID_CRL_DISTRIBUTION_POINTS"
   "NID_MD5WITHRSA"
   "NID_SERIALNUMBER"
   "NID_TITLE"
   "NID_DESCRIPTION"
   "NID_CAST5_CBC"
   "NID_CAST5_ECB"
   "NID_CAST5_CFB64"
   "NID_CAST5_OFB64"
   "NID_PBEWITHMD5ANDCAST5_CBC"
   "NID_DSAWITHSHA1"
   "NID_MD5_SHA1"
   "NID_SHA1WITHRSA"
   "NID_DSA"
   "NID_RIPEMD160"
   "NID_RIPEMD160WITHRSA"
   "NID_RC5_CBC"
   "NID_RC5_ECB"
   "NID_RC5_CFB64"
   "NID_RC5_OFB64"
   "NID_RLE_COMPRESSION"
   "NID_ZLIB_COMPRESSION"
   "NID_EXT_KEY_USAGE"
   "NID_ID_PKIX"
   "NID_ID_KP"
   "NID_SERVER_AUTH"
   "NID_CLIENT_AUTH"
   "NID_CODE_SIGN"
   "NID_EMAIL_PROTECT"
   "NID_TIME_STAMP"
   "NID_MS_CODE_IND"
   "NID_MS_CODE_COM"
   "NID_MS_CTL_SIGN"
   "NID_MS_SGC"
   "NID_MS_EFS"
   "NID_NS_SGC"
   "NID_DELTA_CRL"
   "NID_CRL_REASON"
   "NID_INVALIDITY_DATE"
   "NID_SXNET"
   "NID_PBE_WITHSHA1AND128BITRC4"
   "NID_PBE_WITHSHA1AND40BITRC4"
   "NID_PBE_WITHSHA1AND3_KEY_TRIPLEDES_CBC"
   "NID_PBE_WITHSHA1AND2_KEY_TRIPLEDES_CBC"
   "NID_PBE_WITHSHA1AND128BITRC2_CBC"
   "NID_PBE_WITHSHA1AND40BITRC2_CBC"
   "NID_KEYBAG"
   "NID_PKCS8SHROUDEDKEYBAG"
   "NID_CERTBAG"
   "NID_CRLBAG"
   "NID_SECRETBAG"
   "NID_SAFECONTENTSBAG"
   "NID_FRIENDLYNAME"
   "NID_LOCALKEYID"
   "NID_X509CERTIFICATE"
   "NID_SDSICERTIFICATE"
   "NID_X509CRL"
   "NID_PBES2"
   "NID_PBMAC1"
   "NID_HMACWITHSHA1"
   "NID_ID_QT_CPS"
   "NID_ID_QT_UNOTICE"
   "NID_RC2_64_CBC"
   "NID_SMIMECAPABILITIES"
   "NID_PBEWITHMD2ANDRC2_CBC"
   "NID_PBEWITHMD5ANDRC2_CBC"
   "NID_PBEWITHSHA1ANDDES_CBC"
   "NID_MS_EXT_REQ"
   "NID_EXT_REQ"
   "NID_NAME"
   "NID_DNQUALIFIER"
   "NID_ID_PE"
   "NID_ID_AD"
   "NID_INFO_ACCESS"
   "NID_AD_OCSP"
   "NID_AD_CA_ISSUERS"
   "NID_OCSP_SIGN"
   "NID_ISO"
   "NID_MEMBER_BODY"
   "NID_ISO_US"
   "NID_X9_57"
   "NID_X9CM"
   "NID_PKCS1"
   "NID_PKCS5"
   "NID_SMIME"
   "NID_ID_SMIME_MOD"
   "NID_ID_SMIME_CT"
   "NID_ID_SMIME_AA"
   "NID_ID_SMIME_ALG"
   "NID_ID_SMIME_CD"
   "NID_ID_SMIME_SPQ"
   "NID_ID_SMIME_CTI"
   "NID_ID_SMIME_MOD_CMS"
   "NID_ID_SMIME_MOD_ESS"
   "NID_ID_SMIME_MOD_OID"
   "NID_ID_SMIME_MOD_MSG_V3"
   "NID_ID_SMIME_MOD_ETS_ESIGNATURE_88"
   "NID_ID_SMIME_MOD_ETS_ESIGNATURE_97"
   "NID_ID_SMIME_MOD_ETS_ESIGPOLICY_88"
   "NID_ID_SMIME_MOD_ETS_ESIGPOLICY_97"
   "NID_ID_SMIME_CT_RECEIPT"
   "NID_ID_SMIME_CT_AUTHDATA"
   "NID_ID_SMIME_CT_PUBLISHCERT"
   "NID_ID_SMIME_CT_TSTINFO"
   "NID_ID_SMIME_CT_TDTINFO"
   "NID_ID_SMIME_CT_CONTENTINFO"
   "NID_ID_SMIME_CT_DVCSREQUESTDATA"
   "NID_ID_SMIME_CT_DVCSRESPONSEDATA"
   "NID_ID_SMIME_AA_RECEIPTREQUEST"
   "NID_ID_SMIME_AA_SECURITYLABEL"
   "NID_ID_SMIME_AA_MLEXPANDHISTORY"
   "NID_ID_SMIME_AA_CONTENTHINT"
   "NID_ID_SMIME_AA_MSGSIGDIGEST"
   "NID_ID_SMIME_AA_ENCAPCONTENTTYPE"
   "NID_ID_SMIME_AA_CONTENTIDENTIFIER"
   "NID_ID_SMIME_AA_MACVALUE"
   "NID_ID_SMIME_AA_EQUIVALENTLABELS"
   "NID_ID_SMIME_AA_CONTENTREFERENCE"
   "NID_ID_SMIME_AA_ENCRYPKEYPREF"
   "NID_ID_SMIME_AA_SIGNINGCERTIFICATE"
   "NID_ID_SMIME_AA_SMIMEENCRYPTCERTS"
   "NID_ID_SMIME_AA_TIMESTAMPTOKEN"
   "NID_ID_SMIME_AA_ETS_SIGPOLICYID"
   "NID_ID_SMIME_AA_ETS_COMMITMENTTYPE"
   "NID_ID_SMIME_AA_ETS_SIGNERLOCATION"
   "NID_ID_SMIME_AA_ETS_SIGNERATTR"
   "NID_ID_SMIME_AA_ETS_OTHERSIGCERT"
   "NID_ID_SMIME_AA_ETS_CONTENTTIMESTAMP"
   "NID_ID_SMIME_AA_ETS_CERTIFICATEREFS"
   "NID_ID_SMIME_AA_ETS_REVOCATIONREFS"
   "NID_ID_SMIME_AA_ETS_CERTVALUES"
   "NID_ID_SMIME_AA_ETS_REVOCATIONVALUES"
   "NID_ID_SMIME_AA_ETS_ESCTIMESTAMP"
   "NID_ID_SMIME_AA_ETS_CERTCRLTIMESTAMP"
   "NID_ID_SMIME_AA_ETS_ARCHIVETIMESTAMP"
   "NID_ID_SMIME_AA_SIGNATURETYPE"
   "NID_ID_SMIME_AA_DVCS_DVC"
   "NID_ID_SMIME_ALG_ESDHWITH3DES"
   "NID_ID_SMIME_ALG_ESDHWITHRC2"
   "NID_ID_SMIME_ALG_3DESWRAP"
   "NID_ID_SMIME_ALG_RC2WRAP"
   "NID_ID_SMIME_ALG_ESDH"
   "NID_ID_SMIME_ALG_CMS3DESWRAP"
   "NID_ID_SMIME_ALG_CMSRC2WRAP"
   "NID_ID_SMIME_CD_LDAP"
   "NID_ID_SMIME_SPQ_ETS_SQT_URI"
   "NID_ID_SMIME_SPQ_ETS_SQT_UNOTICE"
   "NID_ID_SMIME_CTI_ETS_PROOFOFORIGIN"
   "NID_ID_SMIME_CTI_ETS_PROOFOFRECEIPT"
   "NID_ID_SMIME_CTI_ETS_PROOFOFDELIVERY"
   "NID_ID_SMIME_CTI_ETS_PROOFOFSENDER"
   "NID_ID_SMIME_CTI_ETS_PROOFOFAPPROVAL"
   "NID_ID_SMIME_CTI_ETS_PROOFOFCREATION"
   "NID_MD4"
   "NID_ID_PKIX_MOD"
   "NID_ID_QT"
   "NID_ID_IT"
   "NID_ID_PKIP"
   "NID_ID_ALG"
   "NID_ID_CMC"
   "NID_ID_ON"
   "NID_ID_PDA"
   "NID_ID_ACA"
   "NID_ID_QCS"
   "NID_ID_CCT"
   "NID_ID_PKIX1_EXPLICIT_88"
   "NID_ID_PKIX1_IMPLICIT_88"
   "NID_ID_PKIX1_EXPLICIT_93"
   "NID_ID_PKIX1_IMPLICIT_93"
   "NID_ID_MOD_CRMF"
   "NID_ID_MOD_CMC"
   "NID_ID_MOD_KEA_PROFILE_88"
   "NID_ID_MOD_KEA_PROFILE_93"
   "NID_ID_MOD_CMP"
   "NID_ID_MOD_QUALIFIED_CERT_88"
   "NID_ID_MOD_QUALIFIED_CERT_93"
   "NID_ID_MOD_ATTRIBUTE_CERT"
   "NID_ID_MOD_TIMESTAMP_PROTOCOL"
   "NID_ID_MOD_OCSP"
   "NID_ID_MOD_DVCS"
   "NID_ID_MOD_CMP2000"
   "NID_BIOMETRICINFO"
   "NID_QCSTATEMENTS"
   "NID_AC_AUDITENTITY"
   "NID_AC_TARGETING"
   "NID_AACONTROLS"
   "NID_SBQP_IPADDRBLOCK"
   "NID_SBQP_AUTONOMOUSSYSNUM"
   "NID_SBQP_ROUTERIDENTIFIER"
   "NID_TEXTNOTICE"
   "NID_IPSECENDSYSTEM"
   "NID_IPSECTUNNEL"
   "NID_IPSECUSER"
   "NID_DVCS"
   "NID_ID_IT_CAPROTENCCERT"
   "NID_ID_IT_SIGNKEYPAIRTYPES"
   "NID_ID_IT_ENCKEYPAIRTYPES"
   "NID_ID_IT_PREFERREDSYMMALG"
   "NID_ID_IT_CAKEYUPDATEINFO"
   "NID_ID_IT_CURRENTCRL"
   "NID_ID_IT_UNSUPPORTEDOIDS"
   "NID_ID_IT_SUBSCRIPTIONREQUEST"
   "NID_ID_IT_SUBSCRIPTIONRESPONSE"
   "NID_ID_IT_KEYPAIRPARAMREQ"
   "NID_ID_IT_KEYPAIRPARAMREP"
   "NID_ID_IT_REVPASSPHRASE"
   "NID_ID_IT_IMPLICITCONFIRM"
   "NID_ID_IT_CONFIRMWAITTIME"
   "NID_ID_IT_ORIGPKIMESSAGE"
   "NID_ID_REGCTRL"
   "NID_ID_REGINFO"
   "NID_ID_REGCTRL_REGTOKEN"
   "NID_ID_REGCTRL_AUTHENTICATOR"
   "NID_ID_REGCTRL_PKIPUBLICATIONINFO"
   "NID_ID_REGCTRL_PKIARCHIVEOPTIONS"
   "NID_ID_REGCTRL_OLDCERTID"
   "NID_ID_REGCTRL_PROTOCOLENCRKEY"
   "NID_ID_REGINFO_UTF8PAIRS"
   "NID_ID_REGINFO_CERTREQ"
   "NID_ID_ALG_DES40"
   "NID_ID_ALG_NOSIGNATURE"
   "NID_ID_ALG_DH_SIG_HMAC_SHA1"
   "NID_ID_ALG_DH_POP"
   "NID_ID_CMC_STATUSINFO"
   "NID_ID_CMC_IDENTIFICATION"
   "NID_ID_CMC_IDENTITYPROOF"
   "NID_ID_CMC_DATARETURN"
   "NID_ID_CMC_TRANSACTIONID"
   "NID_ID_CMC_SENDERNONCE"
   "NID_ID_CMC_RECIPIENTNONCE"
   "NID_ID_CMC_ADDEXTENSIONS"
   "NID_ID_CMC_ENCRYPTEDPOP"
   "NID_ID_CMC_DECRYPTEDPOP"
   "NID_ID_CMC_LRAPOPWITNESS"
   "NID_ID_CMC_GETCERT"
   "NID_ID_CMC_GETCRL"
   "NID_ID_CMC_REVOKEREQUEST"
   "NID_ID_CMC_REGINFO"
   "NID_ID_CMC_RESPONSEINFO"
   "NID_ID_CMC_QUERYPENDING"
   "NID_ID_CMC_POPLINKRANDOM"
   "NID_ID_CMC_POPLINKWITNESS"
   "NID_ID_CMC_CONFIRMCERTACCEPTANCE"
   "NID_ID_ON_PERSONALDATA"
   "NID_ID_PDA_DATEOFBIRTH"
   "NID_ID_PDA_PLACEOFBIRTH"
   "NID_ID_PDA_GENDER"
   "NID_ID_PDA_COUNTRYOFCITIZENSHIP"
   "NID_ID_PDA_COUNTRYOFRESIDENCE"
   "NID_ID_ACA_AUTHENTICATIONINFO"
   "NID_ID_ACA_ACCESSIDENTITY"
   "NID_ID_ACA_CHARGINGIDENTITY"
   "NID_ID_ACA_GROUP"
   "NID_ID_ACA_ROLE"
   "NID_ID_QCS_PKIXQCSYNTAX_V1"
   "NID_ID_CCT_CRS"
   "NID_ID_CCT_PKIDATA"
   "NID_ID_CCT_PKIRESPONSE"
   "NID_AD_TIMESTAMPING"
   "NID_AD_DVCS"
   "NID_ID_PKIX_OCSP_BASIC"
   "NID_ID_PKIX_OCSP_NONCE"
   "NID_ID_PKIX_OCSP_CRLID"
   "NID_ID_PKIX_OCSP_ACCEPTABLERESPONSES"
   "NID_ID_PKIX_OCSP_NOCHECK"
   "NID_ID_PKIX_OCSP_ARCHIVECUTOFF"
   "NID_ID_PKIX_OCSP_SERVICELOCATOR"
   "NID_ID_PKIX_OCSP_EXTENDEDSTATUS"
   "NID_ID_PKIX_OCSP_VALID"
   "NID_ID_PKIX_OCSP_PATH"
   "NID_ID_PKIX_OCSP_TRUSTROOT"
   "NID_ALGORITHM"
   "NID_RSASIGNATURE"
   "NID_X500ALGORITHMS"
   "NID_ORG"
   "NID_DOD"
   "NID_IANA"
   "NID_DIRECTORY"
   "NID_MANAGEMENT"
   "NID_EXPERIMENTAL"
   "NID_PRIVATE"
   "NID_SECURITY"
   "NID_SNMPV2"
   "NID_MAIL"
   "NID_ENTERPRISES"
   "NID_DCOBJECT"
   "NID_DOMAINCOMPONENT"
   "NID_DOMAIN"
   "NID_JOINT_ISO_CCITT"
   "NID_SELECTED_ATTRIBUTE_TYPES"
   "NID_CLEARANCE"
   "NID_MD4WITHRSAENCRYPTION"
   "NID_AC_PROXYING"
   "NID_SINFO_ACCESS"
   "NID_ID_ACA_ENCATTRS"
   "NID_ROLE"
   "NID_POLICY_CONSTRAINTS"
   "NID_TARGET_INFORMATION"
   "NID_NO_REV_AVAIL"
   "NID_CCITT"
   "NID_ANSI_X9_62"
   "NID_X9_62_PRIME_FIELD"
   "NID_X9_62_CHARACTERISTIC_TWO_FIELD"
   "NID_X9_62_ID_ECPUBLICKEY"
   "NID_X9_62_PRIME192V1"
   "NID_X9_62_PRIME192V2"
   "NID_X9_62_PRIME192V3"
   "NID_X9_62_PRIME239V1"
   "NID_X9_62_PRIME239V2"
   "NID_X9_62_PRIME239V3"
   "NID_X9_62_PRIME256V1"
   "NID_ECDSA_WITH_SHA1"
   "NID_MS_CSP_NAME"
   "NID_AES_128_ECB"
   "NID_AES_128_CBC"
   "NID_AES_128_OFB128"
   "NID_AES_128_CFB128"
   "NID_AES_192_ECB"
   "NID_AES_192_CBC"
   "NID_AES_192_OFB128"
   "NID_AES_192_CFB128"
   "NID_AES_256_ECB"
   "NID_AES_256_CBC"
   "NID_AES_256_OFB128"
   "NID_AES_256_CFB128"
   "NID_HOLD_INSTRUCTION_CODE"
   "NID_HOLD_INSTRUCTION_NONE"
   "NID_HOLD_INSTRUCTION_CALL_ISSUER"
   "NID_HOLD_INSTRUCTION_REJECT"
   "NID_DATA"
   "NID_PSS"
   "NID_UCL"
   "NID_PILOT"
   "NID_PILOTATTRIBUTETYPE"
   "NID_PILOTATTRIBUTESYNTAX"
   "NID_PILOTOBJECTCLASS"
   "NID_PILOTGROUPS"
   "NID_IA5STRINGSYNTAX"
   "NID_CASEIGNOREIA5STRINGSYNTAX"
   "NID_PILOTOBJECT"
   "NID_PILOTPERSON"
   "NID_ACCOUNT"
   "NID_DOCUMENT"
   "NID_ROOM"
   "NID_DOCUMENTSERIES"
   "NID_RFC822LOCALPART"
   "NID_DNSDOMAIN"
   "NID_DOMAINRELATEDOBJECT"
   "NID_FRIENDLYCOUNTRY"
   "NID_SIMPLESECURITYOBJECT"
   "NID_PILOTORGANIZATION"
   "NID_PILOTDSA"
   "NID_QUALITYLABELLEDDATA"
   "NID_USERID"
   "NID_TEXTENCODEDORADDRESS"
   "NID_RFC822MAILBOX"
   "NID_INFO"
   "NID_FAVOURITEDRINK"
   "NID_ROOMNUMBER"
   "NID_PHOTO"
   "NID_USERCLASS"
   "NID_HOST"
   "NID_MANAGER"
   "NID_DOCUMENTIDENTIFIER"
   "NID_DOCUMENTTITLE"
   "NID_DOCUMENTVERSION"
   "NID_DOCUMENTAUTHOR"
   "NID_DOCUMENTLOCATION"
   "NID_HOMETELEPHONENUMBER"
   "NID_SECRETARY"
   "NID_OTHERMAILBOX"
   "NID_LASTMODIFIEDTIME"
   "NID_LASTMODIFIEDBY"
   "NID_ARECORD"
   "NID_PILOTATTRIBUTETYPE27"
   "NID_MXRECORD"
   "NID_NSRECORD"
   "NID_SOARECORD"
   "NID_CNAMERECORD"
   "NID_ASSOCIATEDDOMAIN"
   "NID_ASSOCIATEDNAME"
   "NID_HOMEPOSTALADDRESS"
   "NID_PERSONALTITLE"
   "NID_MOBILETELEPHONENUMBER"
   "NID_PAGERTELEPHONENUMBER"
   "NID_FRIENDLYCOUNTRYNAME"
   "NID_ORGANIZATIONALSTATUS"
   "NID_JANETMAILBOX"
   "NID_MAILPREFERENCEOPTION"
   "NID_BUILDINGNAME"
   "NID_DSAQUALITY"
   "NID_SINGLELEVELQUALITY"
   "NID_SUBTREEMINIMUMQUALITY"
   "NID_SUBTREEMAXIMUMQUALITY"
   "NID_PERSONALSIGNATURE"
   "NID_DITREDIRECT"
   "NID_AUDIO"
   "NID_DOCUMENTPUBLISHER"
   "NID_X500UNIQUEIDENTIFIER"
   "NID_MIME_MHS"
   "NID_MIME_MHS_HEADINGS"
   "NID_MIME_MHS_BODIES"
   "NID_ID_HEX_PARTIAL_MESSAGE"
   "NID_ID_HEX_MULTIPART_MESSAGE"
   "NID_GENERATIONQUALIFIER"
   "NID_PSEUDONYM"
   "NID_ID_SET"
   "NID_SET_CTYPE"
   "NID_SET_MSGEXT"
   "NID_SET_ATTR"
   "NID_SET_POLICY"
   "NID_SET_CERTEXT"
   "NID_SET_BRAND"
   "NID_SETCT_PANDATA"
   "NID_SETCT_PANTOKEN"
   "NID_SETCT_PANONLY"
   "NID_SETCT_OIDATA"
   "NID_SETCT_PI"
   "NID_SETCT_PIDATA"
   "NID_SETCT_PIDATAUNSIGNED"
   "NID_SETCT_HODINPUT"
   "NID_SETCT_AUTHRESBAGGAGE"
   "NID_SETCT_AUTHREVREQBAGGAGE"
   "NID_SETCT_AUTHREVRESBAGGAGE"
   "NID_SETCT_CAPTOKENSEQ"
   "NID_SETCT_PINITRESDATA"
   "NID_SETCT_PI_TBS"
   "NID_SETCT_PRESDATA"
   "NID_SETCT_AUTHREQTBS"
   "NID_SETCT_AUTHRESTBS"
   "NID_SETCT_AUTHRESTBSX"
   "NID_SETCT_AUTHTOKENTBS"
   "NID_SETCT_CAPTOKENDATA"
   "NID_SETCT_CAPTOKENTBS"
   "NID_SETCT_ACQCARDCODEMSG"
   "NID_SETCT_AUTHREVREQTBS"
   "NID_SETCT_AUTHREVRESDATA"
   "NID_SETCT_AUTHREVRESTBS"
   "NID_SETCT_CAPREQTBS"
   "NID_SETCT_CAPREQTBSX"
   "NID_SETCT_CAPRESDATA"
   "NID_SETCT_CAPREVREQTBS"
   "NID_SETCT_CAPREVREQTBSX"
   "NID_SETCT_CAPREVRESDATA"
   "NID_SETCT_CREDREQTBS"
   "NID_SETCT_CREDREQTBSX"
   "NID_SETCT_CREDRESDATA"
   "NID_SETCT_CREDREVREQTBS"
   "NID_SETCT_CREDREVREQTBSX"
   "NID_SETCT_CREDREVRESDATA"
   "NID_SETCT_PCERTREQDATA"
   "NID_SETCT_PCERTRESTBS"
   "NID_SETCT_BATCHADMINREQDATA"
   "NID_SETCT_BATCHADMINRESDATA"
   "NID_SETCT_CARDCINITRESTBS"
   "NID_SETCT_MEAQCINITRESTBS"
   "NID_SETCT_REGFORMRESTBS"
   "NID_SETCT_CERTREQDATA"
   "NID_SETCT_CERTREQTBS"
   "NID_SETCT_CERTRESDATA"
   "NID_SETCT_CERTINQREQTBS"
   "NID_SETCT_ERRORTBS"
   "NID_SETCT_PIDUALSIGNEDTBE"
   "NID_SETCT_PIUNSIGNEDTBE"
   "NID_SETCT_AUTHREQTBE"
   "NID_SETCT_AUTHRESTBE"
   "NID_SETCT_AUTHRESTBEX"
   "NID_SETCT_AUTHTOKENTBE"
   "NID_SETCT_CAPTOKENTBE"
   "NID_SETCT_CAPTOKENTBEX"
   "NID_SETCT_ACQCARDCODEMSGTBE"
   "NID_SETCT_AUTHREVREQTBE"
   "NID_SETCT_AUTHREVRESTBE"
   "NID_SETCT_AUTHREVRESTBEB"
   "NID_SETCT_CAPREQTBE"
   "NID_SETCT_CAPREQTBEX"
   "NID_SETCT_CAPRESTBE"
   "NID_SETCT_CAPREVREQTBE"
   "NID_SETCT_CAPREVREQTBEX"
   "NID_SETCT_CAPREVRESTBE"
   "NID_SETCT_CREDREQTBE"
   "NID_SETCT_CREDREQTBEX"
   "NID_SETCT_CREDRESTBE"
   "NID_SETCT_CREDREVREQTBE"
   "NID_SETCT_CREDREVREQTBEX"
   "NID_SETCT_CREDREVRESTBE"
   "NID_SETCT_BATCHADMINREQTBE"
   "NID_SETCT_BATCHADMINRESTBE"
   "NID_SETCT_REGFORMREQTBE"
   "NID_SETCT_CERTREQTBE"
   "NID_SETCT_CERTREQTBEX"
   "NID_SETCT_CERTRESTBE"
   "NID_SETCT_CRLNOTIFICATIONTBS"
   "NID_SETCT_CRLNOTIFICATIONRESTBS"
   "NID_SETCT_BCIDISTRIBUTIONTBS"
   "NID_SETEXT_GENCRYPT"
   "NID_SETEXT_MIAUTH"
   "NID_SETEXT_PINSECURE"
   "NID_SETEXT_PINANY"
   "NID_SETEXT_TRACK2"
   "NID_SETEXT_CV"
   "NID_SET_POLICY_ROOT"
   "NID_SETCEXT_HASHEDROOT"
   "NID_SETCEXT_CERTTYPE"
   "NID_SETCEXT_MERCHDATA"
   "NID_SETCEXT_CCERTREQUIRED"
   "NID_SETCEXT_TUNNELING"
   "NID_SETCEXT_SETEXT"
   "NID_SETCEXT_SETQUALF"
   "NID_SETCEXT_PGWYCAPABILITIES"
   "NID_SETCEXT_TOKENIDENTIFIER"
   "NID_SETCEXT_TRACK2DATA"
   "NID_SETCEXT_TOKENTYPE"
   "NID_SETCEXT_ISSUERCAPABILITIES"
   "NID_SETATTR_CERT"
   "NID_SETATTR_PGWYCAP"
   "NID_SETATTR_TOKENTYPE"
   "NID_SETATTR_ISSCAP"
   "NID_SET_ROOTKEYTHUMB"
   "NID_SET_ADDPOLICY"
   "NID_SETATTR_TOKEN_EMV"
   "NID_SETATTR_TOKEN_B0PRIME"
   "NID_SETATTR_ISSCAP_CVM"
   "NID_SETATTR_ISSCAP_T2"
   "NID_SETATTR_ISSCAP_SIG"
   "NID_SETATTR_GENCRYPTGRM"
   "NID_SETATTR_T2ENC"
   "NID_SETATTR_T2CLEARTXT"
   "NID_SETATTR_TOKICCSIG"
   "NID_SETATTR_SECDEVSIG"
   "NID_SET_BRAND_IATA_ATA"
   "NID_SET_BRAND_DINERS"
   "NID_SET_BRAND_AMERICANEXPRESS"
   "NID_SET_BRAND_JCB"
   "NID_SET_BRAND_VISA"
   "NID_SET_BRAND_MASTERCARD"
   "NID_SET_BRAND_NOVUS"
   "NID_DES_CDMF"
   "NID_RSAOAEPENCRYPTIONSET"
   "NID_MS_SMARTCARD_LOGIN"
   "NID_MS_UPN"
   "NID_AES_128_CFB1"
   "NID_AES_192_CFB1"
   "NID_AES_256_CFB1"
   "NID_AES_128_CFB8"
   "NID_AES_192_CFB8"
   "NID_AES_256_CFB8"
   "NID_DES_CFB1"
   "NID_DES_CFB8"
   "NID_DES_EDE3_CFB1"
   "NID_DES_EDE3_CFB8"


   )


  ;; MJS 11Oct97: historical unix exports which we might want to scrap?
  (:export
    "START-UP-SERVER-AND-MP"
    "WITH-NOTICED-SOCKET-STREAM"
    ))
